Index: issm/trunk/src/mex/Misfit/Misfit.cpp
===================================================================
--- issm/trunk/src/mex/Misfit/Misfit.cpp	(revision 464)
+++ issm/trunk/src/mex/Misfit/Misfit.cpp	(revision 465)
@@ -15,8 +15,11 @@
 	DataSet* loads=NULL;
 	DataSet* materials=NULL;
-	int      analysis_type;
 	double*  u_g=NULL;
 	double*  u_g_obs=NULL;
 	ParameterInputs* inputs=NULL;
+	char*             analysis_type_string=NULL;
+	int               analysis_type;
+	char*             sub_analysis_type_string=NULL;
+	int               sub_analysis_type;
 
 	/* output datasets: */
@@ -34,7 +37,10 @@
 	FetchData((void**)&loads,NULL,NULL,LOADS,"DataSet",NULL);
 	FetchData((void**)&materials,NULL,NULL,MATERIALS,"DataSet",NULL);
-	FetchData((void**)&analysis_type,NULL,NULL,mxGetField(PARAMETERS,0,"analysis_type"),"Integer",NULL);
 	FetchData((void**)&u_g,NULL,NULL,UG,"Vector","Vec");
 	FetchData((void**)&u_g_obs,NULL,NULL,UGOBS,"Vector","Vec");
+	FetchData((void**)&analysis_type_string,NULL,NULL,ANALYSIS,"String",NULL);
+	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
 
 	/*Fetch inputs: */
@@ -43,5 +49,5 @@
 
 	/*!Call core code: */
-	Misfitx(&J, elements,nodes,loads,materials,u_g,u_g_obs,inputs,analysis_type);
+	Misfitx(&J, elements,nodes,loads,materials,u_g,u_g_obs,inputs,analysis_type,sub_analysis_type);
 
 	/*write output : */
@@ -55,5 +61,7 @@
 	xfree((void**)&u_g);
 	xfree((void**)&u_g_obs);
-	delete inputs
+	delete inputs;
+	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 
 	/*end module: */
Index: issm/trunk/src/mex/Misfit/Misfit.h
===================================================================
--- issm/trunk/src/mex/Misfit/Misfit.h	(revision 464)
+++ issm/trunk/src/mex/Misfit/Misfit.h	(revision 465)
@@ -25,4 +25,6 @@
 #define UGOBS (mxArray*)prhs[6]
 #define INPUTS (mxArray*)prhs[7]
+#define ANALYSIS (mxArray*)prhs[8]
+#define SUBANALYSIS (mxArray*)prhs[9]
 
 /* serial output macros: */
@@ -33,5 +35,5 @@
 #define NLHS  1
 #undef NRHS
-#define NRHS  8
+#define NRHS  10
 
 
Index: issm/trunk/src/mex/ModelProcessor/ModelProcessor.cpp
===================================================================
--- issm/trunk/src/mex/ModelProcessor/ModelProcessor.cpp	(revision 464)
+++ issm/trunk/src/mex/ModelProcessor/ModelProcessor.cpp	(revision 465)
@@ -32,13 +32,5 @@
 
 	/*Create elements, nodes and materials: */
-	CreateElementsNodesAndMaterials(&elements,&nodes,&materials,model,MODEL);
-
-	/*Create constraints: */
-	CreateConstraints(&constraints,model,MODEL);
-
-	/*Create loads: */
-	CreateLoads(&loads,model,MODEL);
-	/*Create parameters: */
-	CreateParameters(&parameters,model,MODEL);
+	CreateDataSets(&elements,&nodes,&materials,&constraints, &loads, &parameters, model,MODEL);
 
 	/*Write output data: */
Index: issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.cpp
===================================================================
--- issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.cpp	(revision 464)
+++ issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.cpp	(revision 465)
@@ -16,5 +16,8 @@
 	DataSet* materials=NULL;
 	ParameterInputs* inputs=NULL;
+	char*             analysis_type_string=NULL;
 	int               analysis_type;
+	char*             sub_analysis_type_string=NULL;
+	int               sub_analysis_type;
 
 	/*output: */
@@ -35,5 +38,9 @@
 	
 	/*parameters: */
-	FetchData((void**)&analysis_type,NULL,NULL,mxGetField(PARAMETERS,0,"analysis_type"),"Integer",NULL);
+	FetchData((void**)&analysis_type_string,NULL,NULL,ANALYSIS,"String",NULL);
+	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
+
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
 
 	/*Fetch inputs: */
@@ -42,5 +49,5 @@
 
 	/*!Generate internal degree of freedom numbers: */
-	PenaltyConstraintsx(&converged, &num_unstable_constraints, elements,nodes,loads,materials,inputs,analysis_type); 
+	PenaltyConstraintsx(&converged, &num_unstable_constraints, elements,nodes,loads,materials,inputs,analysis_type,sub_analysis_type); 
 
 	/*write output datasets: */
@@ -56,4 +63,6 @@
 	delete materials;
 	delete inputs;
+	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 
 	/*end module: */
Index: issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.h
===================================================================
--- issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.h	(revision 464)
+++ issm/trunk/src/mex/PenaltyConstraints/PenaltyConstraints.h	(revision 465)
@@ -23,4 +23,6 @@
 #define PARAMETERS (mxArray*)prhs[4]
 #define INPUTS (mxArray*)prhs[5]
+#define ANALYSIS (mxArray*)prhs[6]
+#define SUBANALYSIS (mxArray*)prhs[7]
 
 /* serial output macros: */
@@ -33,5 +35,5 @@
 #define NLHS  3
 #undef NRHS
-#define NRHS  6
+#define NRHS  8
 
 #endif  /* _PENALTYCONSTRAINTS_H */
Index: issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.cpp
===================================================================
--- issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.cpp	(revision 464)
+++ issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.cpp	(revision 465)
@@ -21,4 +21,6 @@
 	int               analysis_type;
 	char*             analysis_type_string=NULL;
+	int               sub_analysis_type;
+	char*             sub_analysis_type_string=NULL;
 	
 	/*Boot module: */
@@ -42,4 +44,7 @@
 	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
 
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
+
 
 	/*Fetch inputs: */
@@ -48,5 +53,5 @@
 
 	/*!Generate stiffnesses from penalties: */
-	PenaltySystemMatricesx(Kgg, pg,elements,nodes,loads,materials,kflag,pflag,inputs,analysis_type); 
+	PenaltySystemMatricesx(Kgg, pg,elements,nodes,loads,materials,kflag,pflag,inputs,analysis_type,sub_analysis_type); 
 
 	/*write output datasets: */
@@ -63,4 +68,5 @@
 	VecFree(&pg);
 	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 
 	/*end module: */
Index: issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.h
===================================================================
--- issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.h	(revision 464)
+++ issm/trunk/src/mex/PenaltySystemMatrices/PenaltySystemMatrices.h	(revision 465)
@@ -26,4 +26,5 @@
 #define INPUTS (mxArray*)prhs[7]
 #define ANALYSIS (mxArray*)prhs[8]
+#define SUBANALYSIS (mxArray*)prhs[9]
 
 /* serial output macros: */
@@ -35,5 +36,5 @@
 #define NLHS  2
 #undef NRHS
-#define NRHS  9
+#define NRHS  10
 
 
Index: issm/trunk/src/mex/SystemMatrices/SystemMatrices.cpp
===================================================================
--- issm/trunk/src/mex/SystemMatrices/SystemMatrices.cpp	(revision 464)
+++ issm/trunk/src/mex/SystemMatrices/SystemMatrices.cpp	(revision 465)
@@ -21,4 +21,6 @@
 	char*             analysis_type_string=NULL;
 	int               analysis_type;
+	char*             sub_analysis_type_string=NULL;
+	int               sub_analysis_type;
 	
 	/* output datasets: */
@@ -46,4 +48,7 @@
 	analysis_type=AnalysisTypeAsEnum(analysis_type_string);
 
+	FetchData((void**)&sub_analysis_type_string,NULL,NULL,SUBANALYSIS,"String",NULL);
+	sub_analysis_type=AnalysisTypeAsEnum(sub_analysis_type_string);
+
 	/*Fetch inputs: */
 	inputs=new ParameterInputs;
@@ -51,5 +56,5 @@
 
 	/*!Generate internal degree of freedom numbers: */
-	SystemMatricesx(&Kgg, &pg,elements,nodes,loads,materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type); 
+	SystemMatricesx(&Kgg, &pg,elements,nodes,loads,materials,kflag,pflag,connectivity,numberofdofspernode,inputs,analysis_type,sub_analysis_type); 
 
 	/*write output datasets: */
@@ -60,4 +65,5 @@
 	/*Free ressources: */
 	xfree((void**)&analysis_type_string);
+	xfree((void**)&sub_analysis_type_string);
 	delete elements;
 	delete nodes;
Index: issm/trunk/src/mex/SystemMatrices/SystemMatrices.h
===================================================================
--- issm/trunk/src/mex/SystemMatrices/SystemMatrices.h	(revision 464)
+++ issm/trunk/src/mex/SystemMatrices/SystemMatrices.h	(revision 465)
@@ -24,4 +24,5 @@
 #define INPUTS (mxArray*)prhs[5]
 #define ANALYSIS (mxArray*)prhs[6]
+#define SUBANALYSIS (mxArray*)prhs[7]
 
 /* serial output macros: */
@@ -33,5 +34,5 @@
 #define NLHS  2
 #undef NRHS
-#define NRHS  7
+#define NRHS  8
 
 
